module adder

-- Define a variadic adder, e.g.

--  adder 0 5        = 5
--  adder 1 10 11    = 21
--  adder 2 18 17 12 = 47
-- ...

-- i.e., first argument gives the number of further arguments to add up

adderTy : Nat -> Type
adderTy O     = Nat
adderTy (S k) = Nat -> adderTy k 

adder : (n : Nat) -> (acc : Nat) -> adderTy n
adder O     acc = acc
adder (S k) acc = \n => adder k (n + acc)




