module Main

import Effect.Select
import Effect.State
import Effect.StdIO

no_attack : (Int, Int) -> (Int, Int) -> Bool
no_attack (x, y) (x', y') 
   = x /= x' && y /= y' && abs (x - x') /= abs (y - y')

rowsIn : Int -> List (Int, Int) -> List Int
rowsIn col qs = [ x | x <- [1..8], all (no_attack (x, col)) qs ]

addQueens : Int -> List (Int, Int) -> 
            Eff m [SELECT] (List (Int, Int)) 
addQueens 0   qs = return qs
addQueens col qs = do row <- select (rowsIn col qs)
--                       update (+1)
                      addQueens (col - 1) ((row, col) :: qs)

getQueens : Maybe (List (Int, Int))
getQueens = run [()] (addQueens 8 [])

testSel : Eff m [SELECT] Int
testSel = do x <- select [4,5]
             y <- select [5,6]
             if (x == y) then select [y] else select []

rtestSel : Maybe Int
rtestSel = run [()] testSel

main : IO ()
main = do let qs = rtestSel
--           let num = the Int (cast (length qs))
--           putStrLn (show num ++ " solutions:")
          putStrLn (show qs)

