module Main

import Effect.State

data Tree a = Leaf 
            | Node (Tree a) a (Tree a)

testTree : Tree String
testTree = Node (Node Leaf "One" (Node Leaf "Two" Leaf))
                "Three"
                (Node (Node Leaf "Four" Leaf) "Five" Leaf)

label : Tree a -> Eff m [STATE Int] (Tree (Int, a))
label Leaf = return Leaf
label (Node l x r) = do l' <- label l
                        lbl <- get
                        put (lbl + 1)
                        r' <- label r
                        return (Node l' (lbl, x) r')


labelFrom : Int -> Tree a -> Tree (Int, a)
labelFrom x t = runPure [x] (label t)
















-------

data Var = Count | Tag

label' : Tree a -> Eff m [Count ::: STATE Int, 
                          Tag ::: STATE Int] (Tree (Int, a))
label' Leaf = do Count :- update (+1)
                 return Leaf
label' (Node l x r) = do l' <- label' l
                         lbl <- Tag :- get
                         Tag :- put (lbl + 1)
                         r' <- label' r
                         return (Node l' (lbl, x) r')

labelFrom' : Int -> Tree a -> (Int, Tree (Int, a))
labelFrom' x t = let ([Count := leaves, _], tree) =
                     runPureEnv [Count := 0, Tag := 0] (label' t) in
                     (leaves, tree)














{-

main : IO ()
main = do let (leaves, tree) = labelFrom' 0 testTree
          putStrLn (show leaves)

-}
