module MyVect

append : Vect a n -> Vect a m -> Vect a (n + m)
append []        ys = ys
append (x :: xs) ys = x :: append xs ys

plus_mO : (m : Nat) -> plus m O = m
(plus O O = O) <== plus_mO
    = refl
(plus (S k) O = S k) <== plus_mO
    = rewrite ((plus k O = k) <== plus_mO) in refl

plus_mSn : (m, n : Nat) -> plus m (S n) = S (plus m n)
plus_mSn O n = refl
plus_mSn (S k) n = let ih = plus_mSn k n in ?pmnS

pc : (n : Nat) -> n + m = m + n
(O + m = m + O) <== pc
    = rewrite ((m + O = m) <== plusZeroRightNeutral) in refl
(S k + m = m + S k) <== pc
    = rewrite ((k + m = m + k) <== pc) in
        rewrite ((S (m + k) = m + S k) <== plusSuccRightSucc) in 
          refl

---------- Proofs ----------

MyVect.pmnS = proof {
  compute;
  intros;
  rewrite ih;
  trivial;
}


